; *****************************************************************************
; *****************************************************************************
;
;       File    : Command.Asm
;       Author  : Paul Robson (autismuk@aol.com)
;       Purpose : Handle the Command Line
;       Created : 9th October 1997
;       Modified: 9th October 1997
;
; *****************************************************************************
; *****************************************************************************

.386p 
.model flat
include extern.inc

.data
FileName dd     0                       ; command line filename
Empty    db     0,0,0,0                 ; dummy filename for empty string
.code

CMHandler Proc
        mov     [FileName],offset Empty ; Default File name is an empty string
        cmp     esi,2                   ; check ARGC
        jnz     _CMH0
        add     edi,4                   ; get the filename
        mov     eax,[edi]               ; pointer
        mov     [FileName],eax          ; & save it for later use.
_CMH0:  ret
EndP CMHandler

CMFileName Proc
        push    esi
        push    edi
        mov     edi,[FileName]          ; edi = org filename
        mov     esi,offset FNBuffer     ; esi = new filename
FNELoop:mov     dl,[edi]                ; copy until . or \0
        mov     [esi],dl                ; found.
        inc     esi
        inc     edi
        cmp     dl,'.'
        je      FNEDone
        cmp     dl,32
        ja      FNELoop
FNEDone:mov     [esi],eax               ; add new extension
        mov     dl,'.'                  ; add the .
        mov     [esi-1],dl
        mov     ebx,offset FNBuffer     ; ebx points to buffer
        pop     edi
        pop     esi
        ret
.data?
FNBuffer db     127 dup (?)             ; buffer
.code
endP CMFileName

end
