; *****************************************************************************
; *****************************************************************************
;
;       File    : Config.Asm
;       Author  : Paul Robson (autismuk@aol.com)
;       Purpose : Configuration Menu
;       Created : 17th October 1997
;       Modified: 17th October 1997
;
;       Functions :
;               CNMenu          Run the configuration menu
;
; *****************************************************************************
; *****************************************************************************

.386p 
.model flat
include extern.inc
.code

CNMenu Proc
_CNM0:  mov     eax,[RedrawFunc]        ; fill in the details - paint first
        cmp     eax,offset ScanLineFrameRedraw
        call    CNGetYesNo
        mov     [dword ptr _CNMD0],eax

        mov     al,[Volume]             ; volume next
        cmp     al,15
        call    CNGetYesNo
        mov     [dword ptr _CNMD1],eax

        mov     eax,[FRMSkip]            ; skip rate
        add     al,48
        mov     [_CNMD2],al

        mov     eax,[FRMRate]            ; frames per tick rate
        add     al,48
        mov     [_CNMD3],al

        mov     eax,[SoundMode]          ; set the sound mode
        add     al,48
        mov     [_CNMD4],al

        mov     ebx,offset CNMenuData
        call    Menu
        cmp     eax,2
        je      _SetPaint
        cmp     eax,3
        je      _SetSkip
        cmp     eax,4
        je      _SetFrame
        cmp     eax,5
        je      _SetSoundOn
        cmp     eax,6
        je      _SetSoundMode

        ret

_SetPaint:
        cmp     [RedrawFunc],offset ScanLineFrameRedraw
        je      _SPT0
        mov     [RedrawFunc],offset ScanLineFrameRedraw
        jmp     _CNM0
_SPT0:  mov     [RedrawFunc],offset FrameSingleRedraw
        jmp     _CNM0

_SetSkip:
        call    GetRate
        mov     [FRMSkip],eax
        jmp     _CNM0
_SetFrame:
        call    GetRate
        mov     [FRMRate],eax
        jmp     _CNM0
_SetSoundOn:
        xor     [Volume],15
        jmp     _CNM0
_SetSoundMode:
        inc     [SoundMode]
        cmp     [SoundMode],3
        jb      _CNM0
        mov     [SoundMode],0
        jmp     _CNM0

GetRate:call    SCRebuild
        mov     ebx,offset CNGRMenu
        call    Menu
        or      eax,eax
        jz      GetRate
        push    eax
        call    SCRebuild
        pop     eax
        ret
CNGRMenu:
        db      9
        db      'Set Rate to 1',0
        db      'Set Rate to 2',0
        db      'Set Rate to 3',0
        db      'Set Rate to 4',0
        db      'Set Rate to 5',0
        db      'Set Rate to 6',0
        db      'Set Rate to 7',0
        db      'Set Rate to 8',0
        db      'Set Rate to 9',0
EndP CNMenu

CNGetYesNo Proc
        je      _CNGY
        mov     eax,[dword ptr _CNGY0]
        ret
_CNGY:  mov     eax,[dword ptr _CNGY0+4]
        ret
_CNGY0: db      'No  Yes '
EndP CNGetYesNo

.data
CNMenuData:
        db      6
        db      'Return to Emulator',0
        db      'Scanline Paint - '
_CNMD0  db      'xxx ',0
        db      'Frame Skip Rate - '
_CNMD2  db      'x',0
        db      'Frames per PC Tick - '
_CNMD3  db      'x',0
        db      'Sound on ? - '
_CNMD1  db      'xxxx',0
        db      'Sound Mode - '
_CNMD4  db      'x',0
end

