/********************************************************************/
/********************************************************************/
/*																	*/
/*					Code Generation File 2							*/
/*																	*/
/********************************************************************/
/********************************************************************/

#include "z80.h"

/********************************************************************/
/*																	*/
/*						Z80 Code Generation							*/
/*																	*/
/*	Generates the 16-bit load/store/add/inc/dec instructions		*/
/*	Generates the push & pull operations							*/
/*																	*/
/********************************************************************/

static char *Reg16[] = { "bc","de","hl","sp" };
static char *Reg16a[] = { "bc","de","hl","af" };

void Gen2(void)
{
int r;
for (r = 0;r < 4;r++)					/* There are 4 register pairs */
	{
	/*	Load Double Register with 16 bit constant */

	Define(G_STD,r*16+1,10,"ld %s,#nnnn",Reg16[r]);
	FetchWord("ax");
	printf("    mov [word ptr _%s],ax\n",Reg16[r]);
	EndDefine();

	/*  Load Memory indirect through BC & DE *ONLY* */

	if (r < 2)
		{
		Define(G_STD,r*16+2,7,"ld (%s),a",Reg16[r]);
		printf("    mov al,[byte ptr _A]\n");
		printf("    mov ebx,[dword ptr _%s]\n",Reg16[r]);
		Write("al");
		EndDefine();
		}

	/* Increment 16-bit register */

	Define(G_STD,r*16+3,6,"inc %s",Reg16[r]);
	printf("    inc [word ptr _%s]\n",Reg16[r]);
	EndDefine();

	/* Add 16 bit register - register */

	Define(G_STD,r*16+9,11,"add hl,%s",Reg16[r]);
	printf("    mov ax,[word ptr _HL]\n");
	printf("    mov bx,[word ptr _%s]\n",Reg16[r]);
	Operation(OP_ADD16);
	printf("    mov [word ptr _HL],ax\n");
	EndDefine();

	/* Load a indirect through bc,de *ONLY* */

	if (r < 2)
		{
		Define(G_STD,r*16+10,7,"ld a,(%s)",Reg16[r]);
		printf("    mov ebx,[dword ptr _%s]\n",Reg16[r]);
		Read("al");
		printf("    mov [byte ptr _a],al\n");
		EndDefine();
		}

	/* Decrement 16 bit register */

	Define(G_STD,r*16+11,6,"dec %s",Reg16[r]);
	printf("    dec [word ptr _%s]\n",Reg16[r]);
	EndDefine();
	}

	/* Generate PUSH and PULL */

	for (r = 0;r < 4;r++)				/* This uses a slightly different */
		{								/* reg set - the last one is AF */
		Define(G_STD,r*16+0xC5,11,"push %s",Reg16a[r]);
		printf("    mov ax,[word ptr _%s]\n",Reg16a[r]);
		Operation(OP_PUSH16);
		EndDefine();

		Define(G_STD,r*16+0xC1,10,"pop %s",Reg16a[r]);
		Operation(OP_POP16);
		printf("    mov [word ptr _%s],ax\n",Reg16a[r]);
		EndDefine();
		}

}
