/********************************************************************/
/********************************************************************/
/*																	*/
/*					Code Generation File 6							*/
/*																	*/
/*	CB Instructions (SET RESET and BIT) in Normal & xD Extended		*/
/*																	*/
/********************************************************************/
/********************************************************************/

#include "z80.h"

static char *Reg8[] = { "b","c","d","e","h","l","(hl)","a","(ixy+rr)" };

/********************************************************************/
/*																	*/
/*						Z80 Code Generation							*/
/*																	*/
/********************************************************************/

void Gen6(void)
{
int Bit,Mask,t1,Reg,Copy;
for (Bit = 0;Bit < 8;Bit++)				/* Work through 8 bits */
	{
	Mask = (1 << Bit);
	for (Reg = 0;Reg < 9;Reg++)			/* 8 registers + (IXY+nn) */
		{
		t1 = (Reg == 6) ? 15 : 8;		/* Work out TStates */
		if (Reg == 8) t1 = 23;
										/* RES bit,reg */
		Define((Reg == 8) ? G_xDCB :G_CB,
			   0x80 + ((Reg == 8) ? 6 : Reg) + Bit * 8,
			   t1,
			   "res %d,%s",Bit,Reg8[Reg]);

		if (Reg == 6 || Reg == 8)		/* RES in memory (HL) or (Ix+nn) */
			{
			if (Reg == 6)  				/* BX is the address */
				printf("    mov bx,[word ptr _HL]\n");
			else
				printf("    mov ebx,[_DCBAddr]\n");

			printf("    push ebx\n");	/* Address saved for later */
			Read("al");
			printf("    and al,0%02xh\n",255-Mask);
			printf("    pop ebx\n");
			Write("al");
			}
		else							/* RES in register */
			printf("    and [_%s],0%02xh\n",Reg8[Reg],255-Mask);

		EndDefine();

										/* SET bit,reg */
		Define((Reg == 8) ? G_xDCB :G_CB,
			   0xC0 + ((Reg == 8) ? 6 : Reg) + Bit * 8,
			   t1,
			   "set %d,%s",Bit,Reg8[Reg]);

		if (Reg == 6 || Reg == 8)		/* SET in memory (HL) or (Ix+nn) */
			{
			if (Reg == 6)  				/* BX is the address */
				printf("    mov bx,[word ptr _HL]\n");
			else
				printf("    mov ebx,[_DCBAddr]\n");

			printf("    push ebx\n");
			Read("al");
			printf("    or al,0%02xh\n",Mask);
			printf("    pop ebx\n");
			Write("al");
			}
		else							/* SET in register */
			printf("    or [_%s],0%02xh\n",Reg8[Reg],Mask);

		EndDefine();

										/* BIT bit,reg */
		t1 = (Reg == 6) ? 12 : 8;		/* Work out TStates */
		if (Reg == 8) t1 = 20;

		Define((Reg == 8) ? G_xDCB:G_CB,/* Define the data */
			   0x40 + ((Reg == 8) ? 6 : Reg) + Bit * 8,
			   t1,
			   "set %d,%s",Bit,Reg8[Reg]);

		if (Reg == 6 || Reg == 8)		/* BIT in memory (HL) or (Ix+nn) */
			{
			if (Reg == 6)  				/* BX is the address */
				printf("    mov bx,[word ptr _HL]\n");
			else
				printf("    mov ebx,[_DCBAddr]\n");
			Read("al");					/* Data to AL */
			}
		else
			printf("    mov al,[_%s]\n",Reg8[Reg]);
		printf("    mov ah,0%02xh\n",Mask);
		printf("    jmp BitCode\n");
		EndDefine();
		}
	}
										/* Come here to do a 'bit' */
Comment("Bit Code. Value in AL, Mask in AH");
printf("BitCode:\n");
printf("    mov cl,al\n");				/* Save the value for later */
printf("    and al,ah\n");				/* Do the mask */
printf("    lahf\n");					/* AH = Flags. */
printf("    and ah,0%02xh ; %s\n",		/* We only want the Z flag */
					F_ZERO,IntToBin(F_ZERO));
printf("    or  ah,0%02xh ; %s\n",		/* We want half-carry set */
					F_HCARRY,IntToBin(F_HCARRY));

Copy = F_COPY5 + F_COPY3 + F_SIGN;		/* We want bits 7,5,3 from value */
printf("    and cl,0%02xh ; %s\n",		/* Bits we wanted from the original */
				  Copy,IntToBin(Copy));	/* Data */
printf("    or  ah,cl\n");				/* Lets get them ! */

printf("    and [byte ptr _F],0%02xh ; %s\n",
								F_CARRY,IntToBin(F_CARRY));
printf("    or [byte ptr _F],ah\n");	/* Get carry from old flag */

printf("    ret\n");
}