/********************************************************************/
/********************************************************************/
/*																	*/
/*					Code Generation File 7							*/
/*																	*/
/*	CB Extended Shifts & Rotates                             		*/
/*																	*/
/********************************************************************/
/********************************************************************/

#include "z80.h"

/********************************************************************/
/*																	*/
/*						Z80 Code Generation							*/
/*																	*/
/********************************************************************/

static char *Reg8[] = { "b","c","d","e","h","l","(hl)","a","(ixy+rr)" };
static char *RotFunc[] = { "rlc","rrc","rl","rr","sla","sra","sll","srl" };

void Gen7(void)
{
int Func,Reg,t1;
for (Reg = 0;Reg < 9;Reg++)				/* 8 registers and (ixy+nn) */
	{
	t1 = 8;               				/* Register op */
	if (Reg == 6) t1 = 15;				/* (HL) */
	if (Reg == 8) t1 = 23;				/* (IXY+n) */

	for (Func = 0;Func < 8;Func++)		/* Now 8 shifting functions */
		{
		Define((Reg == 8) ? G_xDCB : G_CB,
			   Func * 8 + (Reg == 8 ? 6 : Reg),
			   t1,
			   "%s %s",RotFunc[Func],Reg8[Reg]);

		if (Reg == 6 || Reg == 8)		/* Calculate address/read if ind */
			{
			printf("    mov bx,[word ptr %s]\n",
							(Reg == 6 ? "_HL" : "_DCBAddr"));
			printf("    push ebx\n");
			Read("al");
			}
		else							/* Read register */
			printf("    mov al,[byte ptr _%s]\n",Reg8[Reg]);

		Operation(OP_RLC+Func);			/* Do the operation */

		if (Reg == 6 || Reg == 8)		/* Write back if indirect */
			{
			printf("    pop ebx\n");
			Write("al");
			}
		else							/* Write back if register */
			printf("    mov [byte ptr _%s],al\n",Reg8[Reg]);

		EndDefine();
		}
	}
}