/********************************************************************/
/********************************************************************/
/*																	*/
/*					Code Generation File 8							*/
/*																	*/
/*	Extended ED instructions                                  		*/
/*																	*/
/********************************************************************/
/********************************************************************/

#include "z80.h"

/********************************************************************/
/*																	*/
/*						Z80 Code Generation							*/
/*																	*/
/********************************************************************/

static char *Reg8[] = { "b","c","d","e","h","l","(hl)","a" };
static char *Reg16[] = { "bc","de","hl","sp" };

void Gen8(void)
{
int r,l;
char Reg[3];

Define(G_ED,0xFF,0,"IM2 Call");
printf("    mov ax,[word ptr _PC]\n");
Operation(OP_PUSH16);
printf("    xor ebx,ebx\n");
printf("    mov bh,[_I]\n");
printf("    mov bl,255\n");
ReadWord("ax");
printf("    mov [word ptr _PC],ax\n");
EndDefine();

Define(G_ED,01,0,"Tape Function");
printf("    call TapePatch\n");
EndDefine();

for (r = 0;r < 8;r++)					/* OUT (c),r and IN r,(c) */
  if (r != 6)							/* r can't be (HL) */
	{
	Define(G_ED,						/* OUT (c),r */
		   0x41+r*8,
		   12,"out (c),%s",Reg8[r]);
										/* Data to AH, Address to AL */
	printf("    mov ah,[byte ptr _%s]\n",Reg8[r]);
	printf("    mov al,[byte ptr _C]\n");
	printf("    call IOutPort\n");		/* Send it to the I/O */
	EndDefine();

	Define(G_ED,   						/* IN (c),r */
		   0x40+r*8,
		   12,"in %s,(c)",Reg8[r]);
	printf("    mov al,[byte ptr _C]\n");/* Port address from C */
	printf("    mov ah,[byte ptr _B]\n");/* High address from B */
	printf("    call IInPort\n");		/* Read the port */
	printf("    mov [byte ptr _%s],al\n",Reg8[r]);
	printf("    or al,al\n");			/* Flags now set for SZHP */
	SaveStatus(SS_NOCARRY | SS_CLEARN);	/* Copy them */
	EndDefine();

	}

for (r = 0;r < 4;r++)					/* 16 bit register ops */
	{
	Define(G_ED,0x43+r*16,20,			/* LD (nnnn),rr */
				"ld (aaaa),%s",Reg16[r]);
	FetchWord("bx");
	printf("    mov ax,[word ptr _%s]\n",Reg16[r]);
	WriteWord("ax");
	EndDefine();

	Define(G_ED,0x4B+r*16,20,			/* LD rr,(nnnn) */
				"ld %s,(aaaa)",Reg16[r]);
	FetchWord("bx");
	ReadWord("ax");
	printf("    mov [word ptr _%s],ax\n",Reg16[r]);
	EndDefine();
										/* ADC HL,rr */
	Define(G_ED,0x4A+r*16,15,"adc hl,%s",Reg16[r]);
	printf("    mov ax,[word ptr _HL]\n");
	printf("    mov bx,[word ptr _%s]\n",Reg16[r]);
	Operation(OP_ADC16);
	printf("    mov [word ptr _HL],ax\n");
	EndDefine();
										/* SBC HL,rr */
	Define(G_ED,0x42+r*16,15,"sbc hl,%s",Reg16[r]);
	printf("    mov ax,[word ptr _HL]\n");
	printf("    mov bx,[word ptr _%s]\n",Reg16[r]);
	Operation(OP_SBC16);
	printf("    mov [word ptr _HL],ax\n");
	EndDefine();
	}

for (r = 0;r < 3;r++)					/* IM 0..2 */
	{
	Define(G_ED,0x46+r*8+(r != 0 ? 8 : 0),8,"im %d",r);
	printf("    mov [byte ptr _IMode],%d\n",r);
	EndDefine();
	}

Define(G_ED,0x4D,8,"reti");				/* RETI */
Operation(OP_POP16);
printf("    mov [word ptr _PC],ax\n");
EndDefine();

Define(G_ED,0x45,8,"retn");				/* RETN */
Operation(OP_POP16);
printf("    mov [word ptr _PC],ax\n");
printf("    mov al,[_IFF2]\n");
printf("    mov [_IFF1],al\n");
EndDefine();

Define(G_ED,0x44,8,"neg");				/* NEG */
printf("    mov al,[byte ptr _A]\n");
printf("    mov [byte ptr _A],0\n");
Operation(OP_SUB);
EndDefine();

for (r = 0;r < 2;r++)
	{
	strcpy(Reg,"I");
	if (r == 1)		strcpy(Reg,"R");	/* LD I,A and LD R,A */

	Define(G_ED,0x47+r*8,9,"ld %s,a",Reg);
	printf("    mov al,[_A]\n");
	if (r == 1)							/* LD R,A saves Bit 7 */
		{
		printf("    mov [_RBit7],al\n");
		printf("    and [_RBit7],128\n");
		}
	printf("    mov [_%s],al\n",Reg);
	EndDefine();
										/* LD A,I and LD A,R */
	Define(G_ED,0x57+r*8,9,"ld a,%s",Reg);
	printf("    mov al,[_%s]\n",Reg);
	if (r == 1)							/* LD A,R retrieves Bit 7 */
		{
		printf("    and al,127\n");
		printf("    or al,[_RBit7]\n");
		}
	printf("    mov [_A],al\n");
	printf("    or al,al\n");
	SaveStatus(SS_NOCARRY | SS_CLEARN | SS_CLEARH);
	printf("    and [byte ptr _F],0%02xh ; %s\n",
							255-F_PARITY,IntToBin(255-F_PARITY));

	l = Alloc(1);
	printf("    mov al,[_IFF2]\n");		/* Check IFF2 */
	printf("    or  al,al\n");
	printf("    jz %s\n",SysLabel(l));
	printf("    or [byte ptr _F],0%02xh ; %s\n",
							F_PARITY,IntToBin(F_PARITY));
	printf("%s:\n",SysLabel(l));

	EndDefine();

										/* Wierd 12 bit rotates */
	Define(G_ED,0x67+r*8,18,"r%cd",(r == 0 ? 'r' : 'l'));

	printf("    mov ebx,[dword ptr _HL]\n");
	Read("ch");
	printf("    mov cl,[byte ptr _A]\n");

	if (r == 1)
		{
		printf("    rol cl,4\n");
		printf("    rol cx,4\n");		/* RLD */
		}
	else
		{
		printf("    ror cx,4\n");		/* RRD */
		printf("    ror cl,4\n");
		}

	printf("    and cl,00Fh\n");		/* Write back A */
	printf("    and [byte ptr _A],0F0h\n");
	printf("    or [byte ptr _A],cl\n");
	printf("    mov ebx,[dword ptr _HL]\n");
	Write("ch");						/* Write back (HL) */

	printf("    mov al,[byte ptr _A]\n");
	printf("    or al,al\n");			/* Set the flags from A */
	SaveStatus(SS_NOCARRY | SS_CLEARN | SS_CLEARH);

	EndDefine();
	}
}