/********************************************************************/
/********************************************************************/
/*																	*/
/*					Code Generation File 9							*/
/*																	*/
/*	Extended ED instructions (Block moves)							*/
/*																	*/
/********************************************************************/
/********************************************************************/

#include "z80.h"

/********************************************************************/
/*																	*/
/*						Z80 Code Generation							*/
/*																	*/
/********************************************************************/

void Gen9(void)
{
int Dir,Base,f,l,r,n;
char DirChar,*DirAct;
BOOL bSet;
static char *Repeat[] = { "ldi","cpi","ini","outi","ldd","cpd","ind","outd" };

for (Dir = 0;Dir < 2;Dir++)				/* DIR 0 = Up,1 = Down */
	{
	DirChar = (Dir == 0 ? 'i' : 'd');	/* Direction character */
	DirAct = (Dir == 0 ? "inc":"dec");	/* Direction function */
	Base = 0xA0 + Dir * 8;				/* Base opcode */



	Define(G_ED,Base+0,16,				/* LDI LDD */
					"ld%c",DirChar);
										/* Copy the data */
	printf("    mov ebx,[dword ptr _HL]\n");
	Read("al");
	printf("    mov ebx,[dword ptr _DE]\n");
	Write("al");
										/* Adjust the pointers */
	printf("    %s [word ptr _HL]\n",DirAct);
	printf("    %s [word ptr _DE]\n",DirAct);

	f = 255-(F_HCARRY+F_PARITY+F_SUM);	/* Clear N H P */
	printf("    and [byte ptr _F],0%02xh ; %s\n",
											f,IntToBin(f));
	l = Alloc(1);						/* Dec counter. If BC!=0 Set P */
	printf("    dec [word ptr _BC]\n");
	printf("    jz short %s\n",SysLabel(l));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_PARITY,IntToBin(F_PARITY));
	printf("%s:\n",SysLabel(l));

	EndDefine();


										/* CPI CPD */
	Define(G_ED,Base+1,16,"cp%c",DirChar);
	printf("    mov ebx,[dword ptr _HL]\n");
	Read("al");
										/* Test doesn't change C */
	printf("    cmp [byte ptr _A],al\n");
	SaveStatus(SS_SETN + SS_NOCARRY + SS_CLEARP);

	#ifdef BIT35						/* Bits 3 & 5 ? */
	ERROR();
	#endif
										/* Adjust the pointers */
	printf("    %s [word ptr _HL]\n",DirAct);

	l = Alloc(1);						/* Dec counter. If BC!=0 Set P */
	printf("    dec [word ptr _BC]\n");
	printf("    jz short %s\n",SysLabel(l));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_PARITY,IntToBin(F_PARITY));
	printf("%s:\n",SysLabel(l));

	EndDefine();


										/* INI IND */
	Define(G_ED,Base+2,16,"in%c",DirChar);

	printf("    mov al,[byte ptr _C]\n");
	printf("    call IInPort\n");
	printf("    mov ebx,[dword ptr _HL]\n");
	Write("al");
    										/* Adjust the pointers */
	printf("    %s [word ptr _HL]\n",DirAct);

	f = 255-F_ZERO;
	printf("    and [byte ptr _F],0%02xh ; %s\n",f,IntToBin(f));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_SUM,IntToBin(F_SUM));

	l = Alloc(1);						/* Dec counter. If B == 0 Set Z */
	printf("    dec [byte ptr _B]\n");
	printf("    jnz short %s\n",SysLabel(l));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_ZERO,IntToBin(F_ZERO));
	printf("%s:\n",SysLabel(l));

	EndDefine();


										/* OTI OTD */
	Define(G_ED,Base+3,16,"ot%c",DirChar);

	printf("    mov ebx,[dword ptr _HL]\n");
	Read("ah");
	printf("    mov al,[byte ptr _C]\n");
	printf("    call IOutPort\n");

    										/* Adjust the pointers */
	printf("    %s [word ptr _HL]\n",DirAct);

	f = 255-F_ZERO;
	printf("    and [byte ptr _F],0%02xh ; %s\n",f,IntToBin(f));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_SUM,IntToBin(F_SUM));

	l = Alloc(1);						/* Dec counter. If B == 0 Set Z */
	printf("    dec [byte ptr _B]\n");
	printf("    jnz short %s\n",SysLabel(l));
	printf("    or [byte ptr _F],0%02xh ; %s\n",F_ZERO,IntToBin(F_ZERO));
	printf("%s:\n",SysLabel(l));
	EndDefine();
	}

for (r = 0;r < 8;r++)					/* The repeating versions */
	{
	n = 0xB0+r;
	if (r >= 4) n = n+4;
	Define(G_ED,n,0,"%sr",Repeat[r]);
	printf("    call %s\n",OpLabel(G_ED,n-16));

	printf("    mov al,[byte ptr _F]\n");

	switch(r & 3)
		{
		case 0:							/* LDIR loop if Parity Set */
			printf("    and al,0%02xh ; %s\n",F_PARITY,IntToBin(F_PARITY));
			bSet = TRUE;
			break;

		case 1:							/* CPIR loop if Z '0' and P '1' */
			f = F_PARITY+F_ZERO;
			printf("    and al,0%02xh ; %s\n",f,IntToBin(f));
			printf("    xor al,0%02xh ; %s\n",F_PARITY,IntToBin(F_PARITY));
			bSet = FALSE;
			break;

		default:						/* INIR INDR loop if Z '0' */
			printf("    and al,0%02xh ; %s\n",F_ZERO,IntToBin(F_ZERO));
			bSet = FALSE;
		}

	l = Alloc(1);
	printf("    j%s %s\n",(bSet ? "z" : "nz"),SysLabel(l));
	AddCycles(5);

/*	printf("    jmp %s\n",OpLabel(G_ED,n)); */	/* Uninterruptable LDIR */

	printf("    sub [word ptr _PC],2\n");
	printf("%s:\n",SysLabel(l));
	EndDefine();
	}
}